// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from grasping_msgs:action/GraspPlanning.idl
// generated code does not contain a copyright notice
#include "grasping_msgs/action/detail/grasp_planning__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `object`
#include "grasping_msgs/msg/detail/object__functions.h"
// Member `group_name`
#include "rosidl_runtime_c/string_functions.h"

bool
grasping_msgs__action__GraspPlanning_Goal__init(grasping_msgs__action__GraspPlanning_Goal * msg)
{
  if (!msg) {
    return false;
  }
  // object
  if (!grasping_msgs__msg__Object__init(&msg->object)) {
    grasping_msgs__action__GraspPlanning_Goal__fini(msg);
    return false;
  }
  // group_name
  if (!rosidl_runtime_c__String__init(&msg->group_name)) {
    grasping_msgs__action__GraspPlanning_Goal__fini(msg);
    return false;
  }
  return true;
}

void
grasping_msgs__action__GraspPlanning_Goal__fini(grasping_msgs__action__GraspPlanning_Goal * msg)
{
  if (!msg) {
    return;
  }
  // object
  grasping_msgs__msg__Object__fini(&msg->object);
  // group_name
  rosidl_runtime_c__String__fini(&msg->group_name);
}

bool
grasping_msgs__action__GraspPlanning_Goal__are_equal(const grasping_msgs__action__GraspPlanning_Goal * lhs, const grasping_msgs__action__GraspPlanning_Goal * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // object
  if (!grasping_msgs__msg__Object__are_equal(
      &(lhs->object), &(rhs->object)))
  {
    return false;
  }
  // group_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->group_name), &(rhs->group_name)))
  {
    return false;
  }
  return true;
}

bool
grasping_msgs__action__GraspPlanning_Goal__copy(
  const grasping_msgs__action__GraspPlanning_Goal * input,
  grasping_msgs__action__GraspPlanning_Goal * output)
{
  if (!input || !output) {
    return false;
  }
  // object
  if (!grasping_msgs__msg__Object__copy(
      &(input->object), &(output->object)))
  {
    return false;
  }
  // group_name
  if (!rosidl_runtime_c__String__copy(
      &(input->group_name), &(output->group_name)))
  {
    return false;
  }
  return true;
}

grasping_msgs__action__GraspPlanning_Goal *
grasping_msgs__action__GraspPlanning_Goal__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_Goal * msg = (grasping_msgs__action__GraspPlanning_Goal *)allocator.allocate(sizeof(grasping_msgs__action__GraspPlanning_Goal), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(grasping_msgs__action__GraspPlanning_Goal));
  bool success = grasping_msgs__action__GraspPlanning_Goal__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
grasping_msgs__action__GraspPlanning_Goal__destroy(grasping_msgs__action__GraspPlanning_Goal * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    grasping_msgs__action__GraspPlanning_Goal__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
grasping_msgs__action__GraspPlanning_Goal__Sequence__init(grasping_msgs__action__GraspPlanning_Goal__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_Goal * data = NULL;

  if (size) {
    data = (grasping_msgs__action__GraspPlanning_Goal *)allocator.zero_allocate(size, sizeof(grasping_msgs__action__GraspPlanning_Goal), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = grasping_msgs__action__GraspPlanning_Goal__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        grasping_msgs__action__GraspPlanning_Goal__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
grasping_msgs__action__GraspPlanning_Goal__Sequence__fini(grasping_msgs__action__GraspPlanning_Goal__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      grasping_msgs__action__GraspPlanning_Goal__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

grasping_msgs__action__GraspPlanning_Goal__Sequence *
grasping_msgs__action__GraspPlanning_Goal__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_Goal__Sequence * array = (grasping_msgs__action__GraspPlanning_Goal__Sequence *)allocator.allocate(sizeof(grasping_msgs__action__GraspPlanning_Goal__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = grasping_msgs__action__GraspPlanning_Goal__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
grasping_msgs__action__GraspPlanning_Goal__Sequence__destroy(grasping_msgs__action__GraspPlanning_Goal__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    grasping_msgs__action__GraspPlanning_Goal__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
grasping_msgs__action__GraspPlanning_Goal__Sequence__are_equal(const grasping_msgs__action__GraspPlanning_Goal__Sequence * lhs, const grasping_msgs__action__GraspPlanning_Goal__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!grasping_msgs__action__GraspPlanning_Goal__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
grasping_msgs__action__GraspPlanning_Goal__Sequence__copy(
  const grasping_msgs__action__GraspPlanning_Goal__Sequence * input,
  grasping_msgs__action__GraspPlanning_Goal__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(grasping_msgs__action__GraspPlanning_Goal);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    grasping_msgs__action__GraspPlanning_Goal * data =
      (grasping_msgs__action__GraspPlanning_Goal *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!grasping_msgs__action__GraspPlanning_Goal__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          grasping_msgs__action__GraspPlanning_Goal__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!grasping_msgs__action__GraspPlanning_Goal__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `grasps`
#include "moveit_msgs/msg/detail/grasp__functions.h"

bool
grasping_msgs__action__GraspPlanning_Result__init(grasping_msgs__action__GraspPlanning_Result * msg)
{
  if (!msg) {
    return false;
  }
  // grasps
  if (!moveit_msgs__msg__Grasp__Sequence__init(&msg->grasps, 0)) {
    grasping_msgs__action__GraspPlanning_Result__fini(msg);
    return false;
  }
  return true;
}

void
grasping_msgs__action__GraspPlanning_Result__fini(grasping_msgs__action__GraspPlanning_Result * msg)
{
  if (!msg) {
    return;
  }
  // grasps
  moveit_msgs__msg__Grasp__Sequence__fini(&msg->grasps);
}

bool
grasping_msgs__action__GraspPlanning_Result__are_equal(const grasping_msgs__action__GraspPlanning_Result * lhs, const grasping_msgs__action__GraspPlanning_Result * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // grasps
  if (!moveit_msgs__msg__Grasp__Sequence__are_equal(
      &(lhs->grasps), &(rhs->grasps)))
  {
    return false;
  }
  return true;
}

bool
grasping_msgs__action__GraspPlanning_Result__copy(
  const grasping_msgs__action__GraspPlanning_Result * input,
  grasping_msgs__action__GraspPlanning_Result * output)
{
  if (!input || !output) {
    return false;
  }
  // grasps
  if (!moveit_msgs__msg__Grasp__Sequence__copy(
      &(input->grasps), &(output->grasps)))
  {
    return false;
  }
  return true;
}

grasping_msgs__action__GraspPlanning_Result *
grasping_msgs__action__GraspPlanning_Result__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_Result * msg = (grasping_msgs__action__GraspPlanning_Result *)allocator.allocate(sizeof(grasping_msgs__action__GraspPlanning_Result), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(grasping_msgs__action__GraspPlanning_Result));
  bool success = grasping_msgs__action__GraspPlanning_Result__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
grasping_msgs__action__GraspPlanning_Result__destroy(grasping_msgs__action__GraspPlanning_Result * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    grasping_msgs__action__GraspPlanning_Result__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
grasping_msgs__action__GraspPlanning_Result__Sequence__init(grasping_msgs__action__GraspPlanning_Result__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_Result * data = NULL;

  if (size) {
    data = (grasping_msgs__action__GraspPlanning_Result *)allocator.zero_allocate(size, sizeof(grasping_msgs__action__GraspPlanning_Result), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = grasping_msgs__action__GraspPlanning_Result__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        grasping_msgs__action__GraspPlanning_Result__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
grasping_msgs__action__GraspPlanning_Result__Sequence__fini(grasping_msgs__action__GraspPlanning_Result__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      grasping_msgs__action__GraspPlanning_Result__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

grasping_msgs__action__GraspPlanning_Result__Sequence *
grasping_msgs__action__GraspPlanning_Result__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_Result__Sequence * array = (grasping_msgs__action__GraspPlanning_Result__Sequence *)allocator.allocate(sizeof(grasping_msgs__action__GraspPlanning_Result__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = grasping_msgs__action__GraspPlanning_Result__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
grasping_msgs__action__GraspPlanning_Result__Sequence__destroy(grasping_msgs__action__GraspPlanning_Result__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    grasping_msgs__action__GraspPlanning_Result__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
grasping_msgs__action__GraspPlanning_Result__Sequence__are_equal(const grasping_msgs__action__GraspPlanning_Result__Sequence * lhs, const grasping_msgs__action__GraspPlanning_Result__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!grasping_msgs__action__GraspPlanning_Result__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
grasping_msgs__action__GraspPlanning_Result__Sequence__copy(
  const grasping_msgs__action__GraspPlanning_Result__Sequence * input,
  grasping_msgs__action__GraspPlanning_Result__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(grasping_msgs__action__GraspPlanning_Result);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    grasping_msgs__action__GraspPlanning_Result * data =
      (grasping_msgs__action__GraspPlanning_Result *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!grasping_msgs__action__GraspPlanning_Result__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          grasping_msgs__action__GraspPlanning_Result__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!grasping_msgs__action__GraspPlanning_Result__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `grasps`
// already included above
// #include "moveit_msgs/msg/detail/grasp__functions.h"

bool
grasping_msgs__action__GraspPlanning_Feedback__init(grasping_msgs__action__GraspPlanning_Feedback * msg)
{
  if (!msg) {
    return false;
  }
  // grasps
  if (!moveit_msgs__msg__Grasp__Sequence__init(&msg->grasps, 0)) {
    grasping_msgs__action__GraspPlanning_Feedback__fini(msg);
    return false;
  }
  return true;
}

void
grasping_msgs__action__GraspPlanning_Feedback__fini(grasping_msgs__action__GraspPlanning_Feedback * msg)
{
  if (!msg) {
    return;
  }
  // grasps
  moveit_msgs__msg__Grasp__Sequence__fini(&msg->grasps);
}

bool
grasping_msgs__action__GraspPlanning_Feedback__are_equal(const grasping_msgs__action__GraspPlanning_Feedback * lhs, const grasping_msgs__action__GraspPlanning_Feedback * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // grasps
  if (!moveit_msgs__msg__Grasp__Sequence__are_equal(
      &(lhs->grasps), &(rhs->grasps)))
  {
    return false;
  }
  return true;
}

bool
grasping_msgs__action__GraspPlanning_Feedback__copy(
  const grasping_msgs__action__GraspPlanning_Feedback * input,
  grasping_msgs__action__GraspPlanning_Feedback * output)
{
  if (!input || !output) {
    return false;
  }
  // grasps
  if (!moveit_msgs__msg__Grasp__Sequence__copy(
      &(input->grasps), &(output->grasps)))
  {
    return false;
  }
  return true;
}

grasping_msgs__action__GraspPlanning_Feedback *
grasping_msgs__action__GraspPlanning_Feedback__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_Feedback * msg = (grasping_msgs__action__GraspPlanning_Feedback *)allocator.allocate(sizeof(grasping_msgs__action__GraspPlanning_Feedback), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(grasping_msgs__action__GraspPlanning_Feedback));
  bool success = grasping_msgs__action__GraspPlanning_Feedback__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
grasping_msgs__action__GraspPlanning_Feedback__destroy(grasping_msgs__action__GraspPlanning_Feedback * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    grasping_msgs__action__GraspPlanning_Feedback__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
grasping_msgs__action__GraspPlanning_Feedback__Sequence__init(grasping_msgs__action__GraspPlanning_Feedback__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_Feedback * data = NULL;

  if (size) {
    data = (grasping_msgs__action__GraspPlanning_Feedback *)allocator.zero_allocate(size, sizeof(grasping_msgs__action__GraspPlanning_Feedback), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = grasping_msgs__action__GraspPlanning_Feedback__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        grasping_msgs__action__GraspPlanning_Feedback__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
grasping_msgs__action__GraspPlanning_Feedback__Sequence__fini(grasping_msgs__action__GraspPlanning_Feedback__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      grasping_msgs__action__GraspPlanning_Feedback__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

grasping_msgs__action__GraspPlanning_Feedback__Sequence *
grasping_msgs__action__GraspPlanning_Feedback__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_Feedback__Sequence * array = (grasping_msgs__action__GraspPlanning_Feedback__Sequence *)allocator.allocate(sizeof(grasping_msgs__action__GraspPlanning_Feedback__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = grasping_msgs__action__GraspPlanning_Feedback__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
grasping_msgs__action__GraspPlanning_Feedback__Sequence__destroy(grasping_msgs__action__GraspPlanning_Feedback__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    grasping_msgs__action__GraspPlanning_Feedback__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
grasping_msgs__action__GraspPlanning_Feedback__Sequence__are_equal(const grasping_msgs__action__GraspPlanning_Feedback__Sequence * lhs, const grasping_msgs__action__GraspPlanning_Feedback__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!grasping_msgs__action__GraspPlanning_Feedback__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
grasping_msgs__action__GraspPlanning_Feedback__Sequence__copy(
  const grasping_msgs__action__GraspPlanning_Feedback__Sequence * input,
  grasping_msgs__action__GraspPlanning_Feedback__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(grasping_msgs__action__GraspPlanning_Feedback);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    grasping_msgs__action__GraspPlanning_Feedback * data =
      (grasping_msgs__action__GraspPlanning_Feedback *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!grasping_msgs__action__GraspPlanning_Feedback__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          grasping_msgs__action__GraspPlanning_Feedback__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!grasping_msgs__action__GraspPlanning_Feedback__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `goal_id`
#include "unique_identifier_msgs/msg/detail/uuid__functions.h"
// Member `goal`
// already included above
// #include "grasping_msgs/action/detail/grasp_planning__functions.h"

bool
grasping_msgs__action__GraspPlanning_SendGoal_Request__init(grasping_msgs__action__GraspPlanning_SendGoal_Request * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    grasping_msgs__action__GraspPlanning_SendGoal_Request__fini(msg);
    return false;
  }
  // goal
  if (!grasping_msgs__action__GraspPlanning_Goal__init(&msg->goal)) {
    grasping_msgs__action__GraspPlanning_SendGoal_Request__fini(msg);
    return false;
  }
  return true;
}

void
grasping_msgs__action__GraspPlanning_SendGoal_Request__fini(grasping_msgs__action__GraspPlanning_SendGoal_Request * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
  // goal
  grasping_msgs__action__GraspPlanning_Goal__fini(&msg->goal);
}

bool
grasping_msgs__action__GraspPlanning_SendGoal_Request__are_equal(const grasping_msgs__action__GraspPlanning_SendGoal_Request * lhs, const grasping_msgs__action__GraspPlanning_SendGoal_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__are_equal(
      &(lhs->goal_id), &(rhs->goal_id)))
  {
    return false;
  }
  // goal
  if (!grasping_msgs__action__GraspPlanning_Goal__are_equal(
      &(lhs->goal), &(rhs->goal)))
  {
    return false;
  }
  return true;
}

bool
grasping_msgs__action__GraspPlanning_SendGoal_Request__copy(
  const grasping_msgs__action__GraspPlanning_SendGoal_Request * input,
  grasping_msgs__action__GraspPlanning_SendGoal_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__copy(
      &(input->goal_id), &(output->goal_id)))
  {
    return false;
  }
  // goal
  if (!grasping_msgs__action__GraspPlanning_Goal__copy(
      &(input->goal), &(output->goal)))
  {
    return false;
  }
  return true;
}

grasping_msgs__action__GraspPlanning_SendGoal_Request *
grasping_msgs__action__GraspPlanning_SendGoal_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_SendGoal_Request * msg = (grasping_msgs__action__GraspPlanning_SendGoal_Request *)allocator.allocate(sizeof(grasping_msgs__action__GraspPlanning_SendGoal_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(grasping_msgs__action__GraspPlanning_SendGoal_Request));
  bool success = grasping_msgs__action__GraspPlanning_SendGoal_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
grasping_msgs__action__GraspPlanning_SendGoal_Request__destroy(grasping_msgs__action__GraspPlanning_SendGoal_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    grasping_msgs__action__GraspPlanning_SendGoal_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
grasping_msgs__action__GraspPlanning_SendGoal_Request__Sequence__init(grasping_msgs__action__GraspPlanning_SendGoal_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_SendGoal_Request * data = NULL;

  if (size) {
    data = (grasping_msgs__action__GraspPlanning_SendGoal_Request *)allocator.zero_allocate(size, sizeof(grasping_msgs__action__GraspPlanning_SendGoal_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = grasping_msgs__action__GraspPlanning_SendGoal_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        grasping_msgs__action__GraspPlanning_SendGoal_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
grasping_msgs__action__GraspPlanning_SendGoal_Request__Sequence__fini(grasping_msgs__action__GraspPlanning_SendGoal_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      grasping_msgs__action__GraspPlanning_SendGoal_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

grasping_msgs__action__GraspPlanning_SendGoal_Request__Sequence *
grasping_msgs__action__GraspPlanning_SendGoal_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_SendGoal_Request__Sequence * array = (grasping_msgs__action__GraspPlanning_SendGoal_Request__Sequence *)allocator.allocate(sizeof(grasping_msgs__action__GraspPlanning_SendGoal_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = grasping_msgs__action__GraspPlanning_SendGoal_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
grasping_msgs__action__GraspPlanning_SendGoal_Request__Sequence__destroy(grasping_msgs__action__GraspPlanning_SendGoal_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    grasping_msgs__action__GraspPlanning_SendGoal_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
grasping_msgs__action__GraspPlanning_SendGoal_Request__Sequence__are_equal(const grasping_msgs__action__GraspPlanning_SendGoal_Request__Sequence * lhs, const grasping_msgs__action__GraspPlanning_SendGoal_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!grasping_msgs__action__GraspPlanning_SendGoal_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
grasping_msgs__action__GraspPlanning_SendGoal_Request__Sequence__copy(
  const grasping_msgs__action__GraspPlanning_SendGoal_Request__Sequence * input,
  grasping_msgs__action__GraspPlanning_SendGoal_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(grasping_msgs__action__GraspPlanning_SendGoal_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    grasping_msgs__action__GraspPlanning_SendGoal_Request * data =
      (grasping_msgs__action__GraspPlanning_SendGoal_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!grasping_msgs__action__GraspPlanning_SendGoal_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          grasping_msgs__action__GraspPlanning_SendGoal_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!grasping_msgs__action__GraspPlanning_SendGoal_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `stamp`
#include "builtin_interfaces/msg/detail/time__functions.h"

bool
grasping_msgs__action__GraspPlanning_SendGoal_Response__init(grasping_msgs__action__GraspPlanning_SendGoal_Response * msg)
{
  if (!msg) {
    return false;
  }
  // accepted
  // stamp
  if (!builtin_interfaces__msg__Time__init(&msg->stamp)) {
    grasping_msgs__action__GraspPlanning_SendGoal_Response__fini(msg);
    return false;
  }
  return true;
}

void
grasping_msgs__action__GraspPlanning_SendGoal_Response__fini(grasping_msgs__action__GraspPlanning_SendGoal_Response * msg)
{
  if (!msg) {
    return;
  }
  // accepted
  // stamp
  builtin_interfaces__msg__Time__fini(&msg->stamp);
}

bool
grasping_msgs__action__GraspPlanning_SendGoal_Response__are_equal(const grasping_msgs__action__GraspPlanning_SendGoal_Response * lhs, const grasping_msgs__action__GraspPlanning_SendGoal_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // accepted
  if (lhs->accepted != rhs->accepted) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->stamp), &(rhs->stamp)))
  {
    return false;
  }
  return true;
}

bool
grasping_msgs__action__GraspPlanning_SendGoal_Response__copy(
  const grasping_msgs__action__GraspPlanning_SendGoal_Response * input,
  grasping_msgs__action__GraspPlanning_SendGoal_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // accepted
  output->accepted = input->accepted;
  // stamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->stamp), &(output->stamp)))
  {
    return false;
  }
  return true;
}

grasping_msgs__action__GraspPlanning_SendGoal_Response *
grasping_msgs__action__GraspPlanning_SendGoal_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_SendGoal_Response * msg = (grasping_msgs__action__GraspPlanning_SendGoal_Response *)allocator.allocate(sizeof(grasping_msgs__action__GraspPlanning_SendGoal_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(grasping_msgs__action__GraspPlanning_SendGoal_Response));
  bool success = grasping_msgs__action__GraspPlanning_SendGoal_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
grasping_msgs__action__GraspPlanning_SendGoal_Response__destroy(grasping_msgs__action__GraspPlanning_SendGoal_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    grasping_msgs__action__GraspPlanning_SendGoal_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
grasping_msgs__action__GraspPlanning_SendGoal_Response__Sequence__init(grasping_msgs__action__GraspPlanning_SendGoal_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_SendGoal_Response * data = NULL;

  if (size) {
    data = (grasping_msgs__action__GraspPlanning_SendGoal_Response *)allocator.zero_allocate(size, sizeof(grasping_msgs__action__GraspPlanning_SendGoal_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = grasping_msgs__action__GraspPlanning_SendGoal_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        grasping_msgs__action__GraspPlanning_SendGoal_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
grasping_msgs__action__GraspPlanning_SendGoal_Response__Sequence__fini(grasping_msgs__action__GraspPlanning_SendGoal_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      grasping_msgs__action__GraspPlanning_SendGoal_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

grasping_msgs__action__GraspPlanning_SendGoal_Response__Sequence *
grasping_msgs__action__GraspPlanning_SendGoal_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_SendGoal_Response__Sequence * array = (grasping_msgs__action__GraspPlanning_SendGoal_Response__Sequence *)allocator.allocate(sizeof(grasping_msgs__action__GraspPlanning_SendGoal_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = grasping_msgs__action__GraspPlanning_SendGoal_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
grasping_msgs__action__GraspPlanning_SendGoal_Response__Sequence__destroy(grasping_msgs__action__GraspPlanning_SendGoal_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    grasping_msgs__action__GraspPlanning_SendGoal_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
grasping_msgs__action__GraspPlanning_SendGoal_Response__Sequence__are_equal(const grasping_msgs__action__GraspPlanning_SendGoal_Response__Sequence * lhs, const grasping_msgs__action__GraspPlanning_SendGoal_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!grasping_msgs__action__GraspPlanning_SendGoal_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
grasping_msgs__action__GraspPlanning_SendGoal_Response__Sequence__copy(
  const grasping_msgs__action__GraspPlanning_SendGoal_Response__Sequence * input,
  grasping_msgs__action__GraspPlanning_SendGoal_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(grasping_msgs__action__GraspPlanning_SendGoal_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    grasping_msgs__action__GraspPlanning_SendGoal_Response * data =
      (grasping_msgs__action__GraspPlanning_SendGoal_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!grasping_msgs__action__GraspPlanning_SendGoal_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          grasping_msgs__action__GraspPlanning_SendGoal_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!grasping_msgs__action__GraspPlanning_SendGoal_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `info`
#include "service_msgs/msg/detail/service_event_info__functions.h"
// Member `request`
// Member `response`
// already included above
// #include "grasping_msgs/action/detail/grasp_planning__functions.h"

bool
grasping_msgs__action__GraspPlanning_SendGoal_Event__init(grasping_msgs__action__GraspPlanning_SendGoal_Event * msg)
{
  if (!msg) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__init(&msg->info)) {
    grasping_msgs__action__GraspPlanning_SendGoal_Event__fini(msg);
    return false;
  }
  // request
  if (!grasping_msgs__action__GraspPlanning_SendGoal_Request__Sequence__init(&msg->request, 0)) {
    grasping_msgs__action__GraspPlanning_SendGoal_Event__fini(msg);
    return false;
  }
  // response
  if (!grasping_msgs__action__GraspPlanning_SendGoal_Response__Sequence__init(&msg->response, 0)) {
    grasping_msgs__action__GraspPlanning_SendGoal_Event__fini(msg);
    return false;
  }
  return true;
}

void
grasping_msgs__action__GraspPlanning_SendGoal_Event__fini(grasping_msgs__action__GraspPlanning_SendGoal_Event * msg)
{
  if (!msg) {
    return;
  }
  // info
  service_msgs__msg__ServiceEventInfo__fini(&msg->info);
  // request
  grasping_msgs__action__GraspPlanning_SendGoal_Request__Sequence__fini(&msg->request);
  // response
  grasping_msgs__action__GraspPlanning_SendGoal_Response__Sequence__fini(&msg->response);
}

bool
grasping_msgs__action__GraspPlanning_SendGoal_Event__are_equal(const grasping_msgs__action__GraspPlanning_SendGoal_Event * lhs, const grasping_msgs__action__GraspPlanning_SendGoal_Event * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__are_equal(
      &(lhs->info), &(rhs->info)))
  {
    return false;
  }
  // request
  if (!grasping_msgs__action__GraspPlanning_SendGoal_Request__Sequence__are_equal(
      &(lhs->request), &(rhs->request)))
  {
    return false;
  }
  // response
  if (!grasping_msgs__action__GraspPlanning_SendGoal_Response__Sequence__are_equal(
      &(lhs->response), &(rhs->response)))
  {
    return false;
  }
  return true;
}

bool
grasping_msgs__action__GraspPlanning_SendGoal_Event__copy(
  const grasping_msgs__action__GraspPlanning_SendGoal_Event * input,
  grasping_msgs__action__GraspPlanning_SendGoal_Event * output)
{
  if (!input || !output) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__copy(
      &(input->info), &(output->info)))
  {
    return false;
  }
  // request
  if (!grasping_msgs__action__GraspPlanning_SendGoal_Request__Sequence__copy(
      &(input->request), &(output->request)))
  {
    return false;
  }
  // response
  if (!grasping_msgs__action__GraspPlanning_SendGoal_Response__Sequence__copy(
      &(input->response), &(output->response)))
  {
    return false;
  }
  return true;
}

grasping_msgs__action__GraspPlanning_SendGoal_Event *
grasping_msgs__action__GraspPlanning_SendGoal_Event__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_SendGoal_Event * msg = (grasping_msgs__action__GraspPlanning_SendGoal_Event *)allocator.allocate(sizeof(grasping_msgs__action__GraspPlanning_SendGoal_Event), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(grasping_msgs__action__GraspPlanning_SendGoal_Event));
  bool success = grasping_msgs__action__GraspPlanning_SendGoal_Event__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
grasping_msgs__action__GraspPlanning_SendGoal_Event__destroy(grasping_msgs__action__GraspPlanning_SendGoal_Event * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    grasping_msgs__action__GraspPlanning_SendGoal_Event__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
grasping_msgs__action__GraspPlanning_SendGoal_Event__Sequence__init(grasping_msgs__action__GraspPlanning_SendGoal_Event__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_SendGoal_Event * data = NULL;

  if (size) {
    data = (grasping_msgs__action__GraspPlanning_SendGoal_Event *)allocator.zero_allocate(size, sizeof(grasping_msgs__action__GraspPlanning_SendGoal_Event), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = grasping_msgs__action__GraspPlanning_SendGoal_Event__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        grasping_msgs__action__GraspPlanning_SendGoal_Event__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
grasping_msgs__action__GraspPlanning_SendGoal_Event__Sequence__fini(grasping_msgs__action__GraspPlanning_SendGoal_Event__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      grasping_msgs__action__GraspPlanning_SendGoal_Event__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

grasping_msgs__action__GraspPlanning_SendGoal_Event__Sequence *
grasping_msgs__action__GraspPlanning_SendGoal_Event__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_SendGoal_Event__Sequence * array = (grasping_msgs__action__GraspPlanning_SendGoal_Event__Sequence *)allocator.allocate(sizeof(grasping_msgs__action__GraspPlanning_SendGoal_Event__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = grasping_msgs__action__GraspPlanning_SendGoal_Event__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
grasping_msgs__action__GraspPlanning_SendGoal_Event__Sequence__destroy(grasping_msgs__action__GraspPlanning_SendGoal_Event__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    grasping_msgs__action__GraspPlanning_SendGoal_Event__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
grasping_msgs__action__GraspPlanning_SendGoal_Event__Sequence__are_equal(const grasping_msgs__action__GraspPlanning_SendGoal_Event__Sequence * lhs, const grasping_msgs__action__GraspPlanning_SendGoal_Event__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!grasping_msgs__action__GraspPlanning_SendGoal_Event__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
grasping_msgs__action__GraspPlanning_SendGoal_Event__Sequence__copy(
  const grasping_msgs__action__GraspPlanning_SendGoal_Event__Sequence * input,
  grasping_msgs__action__GraspPlanning_SendGoal_Event__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(grasping_msgs__action__GraspPlanning_SendGoal_Event);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    grasping_msgs__action__GraspPlanning_SendGoal_Event * data =
      (grasping_msgs__action__GraspPlanning_SendGoal_Event *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!grasping_msgs__action__GraspPlanning_SendGoal_Event__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          grasping_msgs__action__GraspPlanning_SendGoal_Event__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!grasping_msgs__action__GraspPlanning_SendGoal_Event__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `goal_id`
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__functions.h"

bool
grasping_msgs__action__GraspPlanning_GetResult_Request__init(grasping_msgs__action__GraspPlanning_GetResult_Request * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    grasping_msgs__action__GraspPlanning_GetResult_Request__fini(msg);
    return false;
  }
  return true;
}

void
grasping_msgs__action__GraspPlanning_GetResult_Request__fini(grasping_msgs__action__GraspPlanning_GetResult_Request * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
}

bool
grasping_msgs__action__GraspPlanning_GetResult_Request__are_equal(const grasping_msgs__action__GraspPlanning_GetResult_Request * lhs, const grasping_msgs__action__GraspPlanning_GetResult_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__are_equal(
      &(lhs->goal_id), &(rhs->goal_id)))
  {
    return false;
  }
  return true;
}

bool
grasping_msgs__action__GraspPlanning_GetResult_Request__copy(
  const grasping_msgs__action__GraspPlanning_GetResult_Request * input,
  grasping_msgs__action__GraspPlanning_GetResult_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__copy(
      &(input->goal_id), &(output->goal_id)))
  {
    return false;
  }
  return true;
}

grasping_msgs__action__GraspPlanning_GetResult_Request *
grasping_msgs__action__GraspPlanning_GetResult_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_GetResult_Request * msg = (grasping_msgs__action__GraspPlanning_GetResult_Request *)allocator.allocate(sizeof(grasping_msgs__action__GraspPlanning_GetResult_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(grasping_msgs__action__GraspPlanning_GetResult_Request));
  bool success = grasping_msgs__action__GraspPlanning_GetResult_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
grasping_msgs__action__GraspPlanning_GetResult_Request__destroy(grasping_msgs__action__GraspPlanning_GetResult_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    grasping_msgs__action__GraspPlanning_GetResult_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
grasping_msgs__action__GraspPlanning_GetResult_Request__Sequence__init(grasping_msgs__action__GraspPlanning_GetResult_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_GetResult_Request * data = NULL;

  if (size) {
    data = (grasping_msgs__action__GraspPlanning_GetResult_Request *)allocator.zero_allocate(size, sizeof(grasping_msgs__action__GraspPlanning_GetResult_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = grasping_msgs__action__GraspPlanning_GetResult_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        grasping_msgs__action__GraspPlanning_GetResult_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
grasping_msgs__action__GraspPlanning_GetResult_Request__Sequence__fini(grasping_msgs__action__GraspPlanning_GetResult_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      grasping_msgs__action__GraspPlanning_GetResult_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

grasping_msgs__action__GraspPlanning_GetResult_Request__Sequence *
grasping_msgs__action__GraspPlanning_GetResult_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_GetResult_Request__Sequence * array = (grasping_msgs__action__GraspPlanning_GetResult_Request__Sequence *)allocator.allocate(sizeof(grasping_msgs__action__GraspPlanning_GetResult_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = grasping_msgs__action__GraspPlanning_GetResult_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
grasping_msgs__action__GraspPlanning_GetResult_Request__Sequence__destroy(grasping_msgs__action__GraspPlanning_GetResult_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    grasping_msgs__action__GraspPlanning_GetResult_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
grasping_msgs__action__GraspPlanning_GetResult_Request__Sequence__are_equal(const grasping_msgs__action__GraspPlanning_GetResult_Request__Sequence * lhs, const grasping_msgs__action__GraspPlanning_GetResult_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!grasping_msgs__action__GraspPlanning_GetResult_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
grasping_msgs__action__GraspPlanning_GetResult_Request__Sequence__copy(
  const grasping_msgs__action__GraspPlanning_GetResult_Request__Sequence * input,
  grasping_msgs__action__GraspPlanning_GetResult_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(grasping_msgs__action__GraspPlanning_GetResult_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    grasping_msgs__action__GraspPlanning_GetResult_Request * data =
      (grasping_msgs__action__GraspPlanning_GetResult_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!grasping_msgs__action__GraspPlanning_GetResult_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          grasping_msgs__action__GraspPlanning_GetResult_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!grasping_msgs__action__GraspPlanning_GetResult_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `result`
// already included above
// #include "grasping_msgs/action/detail/grasp_planning__functions.h"

bool
grasping_msgs__action__GraspPlanning_GetResult_Response__init(grasping_msgs__action__GraspPlanning_GetResult_Response * msg)
{
  if (!msg) {
    return false;
  }
  // status
  // result
  if (!grasping_msgs__action__GraspPlanning_Result__init(&msg->result)) {
    grasping_msgs__action__GraspPlanning_GetResult_Response__fini(msg);
    return false;
  }
  return true;
}

void
grasping_msgs__action__GraspPlanning_GetResult_Response__fini(grasping_msgs__action__GraspPlanning_GetResult_Response * msg)
{
  if (!msg) {
    return;
  }
  // status
  // result
  grasping_msgs__action__GraspPlanning_Result__fini(&msg->result);
}

bool
grasping_msgs__action__GraspPlanning_GetResult_Response__are_equal(const grasping_msgs__action__GraspPlanning_GetResult_Response * lhs, const grasping_msgs__action__GraspPlanning_GetResult_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // status
  if (lhs->status != rhs->status) {
    return false;
  }
  // result
  if (!grasping_msgs__action__GraspPlanning_Result__are_equal(
      &(lhs->result), &(rhs->result)))
  {
    return false;
  }
  return true;
}

bool
grasping_msgs__action__GraspPlanning_GetResult_Response__copy(
  const grasping_msgs__action__GraspPlanning_GetResult_Response * input,
  grasping_msgs__action__GraspPlanning_GetResult_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // status
  output->status = input->status;
  // result
  if (!grasping_msgs__action__GraspPlanning_Result__copy(
      &(input->result), &(output->result)))
  {
    return false;
  }
  return true;
}

grasping_msgs__action__GraspPlanning_GetResult_Response *
grasping_msgs__action__GraspPlanning_GetResult_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_GetResult_Response * msg = (grasping_msgs__action__GraspPlanning_GetResult_Response *)allocator.allocate(sizeof(grasping_msgs__action__GraspPlanning_GetResult_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(grasping_msgs__action__GraspPlanning_GetResult_Response));
  bool success = grasping_msgs__action__GraspPlanning_GetResult_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
grasping_msgs__action__GraspPlanning_GetResult_Response__destroy(grasping_msgs__action__GraspPlanning_GetResult_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    grasping_msgs__action__GraspPlanning_GetResult_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
grasping_msgs__action__GraspPlanning_GetResult_Response__Sequence__init(grasping_msgs__action__GraspPlanning_GetResult_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_GetResult_Response * data = NULL;

  if (size) {
    data = (grasping_msgs__action__GraspPlanning_GetResult_Response *)allocator.zero_allocate(size, sizeof(grasping_msgs__action__GraspPlanning_GetResult_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = grasping_msgs__action__GraspPlanning_GetResult_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        grasping_msgs__action__GraspPlanning_GetResult_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
grasping_msgs__action__GraspPlanning_GetResult_Response__Sequence__fini(grasping_msgs__action__GraspPlanning_GetResult_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      grasping_msgs__action__GraspPlanning_GetResult_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

grasping_msgs__action__GraspPlanning_GetResult_Response__Sequence *
grasping_msgs__action__GraspPlanning_GetResult_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_GetResult_Response__Sequence * array = (grasping_msgs__action__GraspPlanning_GetResult_Response__Sequence *)allocator.allocate(sizeof(grasping_msgs__action__GraspPlanning_GetResult_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = grasping_msgs__action__GraspPlanning_GetResult_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
grasping_msgs__action__GraspPlanning_GetResult_Response__Sequence__destroy(grasping_msgs__action__GraspPlanning_GetResult_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    grasping_msgs__action__GraspPlanning_GetResult_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
grasping_msgs__action__GraspPlanning_GetResult_Response__Sequence__are_equal(const grasping_msgs__action__GraspPlanning_GetResult_Response__Sequence * lhs, const grasping_msgs__action__GraspPlanning_GetResult_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!grasping_msgs__action__GraspPlanning_GetResult_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
grasping_msgs__action__GraspPlanning_GetResult_Response__Sequence__copy(
  const grasping_msgs__action__GraspPlanning_GetResult_Response__Sequence * input,
  grasping_msgs__action__GraspPlanning_GetResult_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(grasping_msgs__action__GraspPlanning_GetResult_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    grasping_msgs__action__GraspPlanning_GetResult_Response * data =
      (grasping_msgs__action__GraspPlanning_GetResult_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!grasping_msgs__action__GraspPlanning_GetResult_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          grasping_msgs__action__GraspPlanning_GetResult_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!grasping_msgs__action__GraspPlanning_GetResult_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `info`
// already included above
// #include "service_msgs/msg/detail/service_event_info__functions.h"
// Member `request`
// Member `response`
// already included above
// #include "grasping_msgs/action/detail/grasp_planning__functions.h"

bool
grasping_msgs__action__GraspPlanning_GetResult_Event__init(grasping_msgs__action__GraspPlanning_GetResult_Event * msg)
{
  if (!msg) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__init(&msg->info)) {
    grasping_msgs__action__GraspPlanning_GetResult_Event__fini(msg);
    return false;
  }
  // request
  if (!grasping_msgs__action__GraspPlanning_GetResult_Request__Sequence__init(&msg->request, 0)) {
    grasping_msgs__action__GraspPlanning_GetResult_Event__fini(msg);
    return false;
  }
  // response
  if (!grasping_msgs__action__GraspPlanning_GetResult_Response__Sequence__init(&msg->response, 0)) {
    grasping_msgs__action__GraspPlanning_GetResult_Event__fini(msg);
    return false;
  }
  return true;
}

void
grasping_msgs__action__GraspPlanning_GetResult_Event__fini(grasping_msgs__action__GraspPlanning_GetResult_Event * msg)
{
  if (!msg) {
    return;
  }
  // info
  service_msgs__msg__ServiceEventInfo__fini(&msg->info);
  // request
  grasping_msgs__action__GraspPlanning_GetResult_Request__Sequence__fini(&msg->request);
  // response
  grasping_msgs__action__GraspPlanning_GetResult_Response__Sequence__fini(&msg->response);
}

bool
grasping_msgs__action__GraspPlanning_GetResult_Event__are_equal(const grasping_msgs__action__GraspPlanning_GetResult_Event * lhs, const grasping_msgs__action__GraspPlanning_GetResult_Event * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__are_equal(
      &(lhs->info), &(rhs->info)))
  {
    return false;
  }
  // request
  if (!grasping_msgs__action__GraspPlanning_GetResult_Request__Sequence__are_equal(
      &(lhs->request), &(rhs->request)))
  {
    return false;
  }
  // response
  if (!grasping_msgs__action__GraspPlanning_GetResult_Response__Sequence__are_equal(
      &(lhs->response), &(rhs->response)))
  {
    return false;
  }
  return true;
}

bool
grasping_msgs__action__GraspPlanning_GetResult_Event__copy(
  const grasping_msgs__action__GraspPlanning_GetResult_Event * input,
  grasping_msgs__action__GraspPlanning_GetResult_Event * output)
{
  if (!input || !output) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__copy(
      &(input->info), &(output->info)))
  {
    return false;
  }
  // request
  if (!grasping_msgs__action__GraspPlanning_GetResult_Request__Sequence__copy(
      &(input->request), &(output->request)))
  {
    return false;
  }
  // response
  if (!grasping_msgs__action__GraspPlanning_GetResult_Response__Sequence__copy(
      &(input->response), &(output->response)))
  {
    return false;
  }
  return true;
}

grasping_msgs__action__GraspPlanning_GetResult_Event *
grasping_msgs__action__GraspPlanning_GetResult_Event__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_GetResult_Event * msg = (grasping_msgs__action__GraspPlanning_GetResult_Event *)allocator.allocate(sizeof(grasping_msgs__action__GraspPlanning_GetResult_Event), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(grasping_msgs__action__GraspPlanning_GetResult_Event));
  bool success = grasping_msgs__action__GraspPlanning_GetResult_Event__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
grasping_msgs__action__GraspPlanning_GetResult_Event__destroy(grasping_msgs__action__GraspPlanning_GetResult_Event * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    grasping_msgs__action__GraspPlanning_GetResult_Event__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
grasping_msgs__action__GraspPlanning_GetResult_Event__Sequence__init(grasping_msgs__action__GraspPlanning_GetResult_Event__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_GetResult_Event * data = NULL;

  if (size) {
    data = (grasping_msgs__action__GraspPlanning_GetResult_Event *)allocator.zero_allocate(size, sizeof(grasping_msgs__action__GraspPlanning_GetResult_Event), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = grasping_msgs__action__GraspPlanning_GetResult_Event__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        grasping_msgs__action__GraspPlanning_GetResult_Event__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
grasping_msgs__action__GraspPlanning_GetResult_Event__Sequence__fini(grasping_msgs__action__GraspPlanning_GetResult_Event__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      grasping_msgs__action__GraspPlanning_GetResult_Event__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

grasping_msgs__action__GraspPlanning_GetResult_Event__Sequence *
grasping_msgs__action__GraspPlanning_GetResult_Event__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_GetResult_Event__Sequence * array = (grasping_msgs__action__GraspPlanning_GetResult_Event__Sequence *)allocator.allocate(sizeof(grasping_msgs__action__GraspPlanning_GetResult_Event__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = grasping_msgs__action__GraspPlanning_GetResult_Event__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
grasping_msgs__action__GraspPlanning_GetResult_Event__Sequence__destroy(grasping_msgs__action__GraspPlanning_GetResult_Event__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    grasping_msgs__action__GraspPlanning_GetResult_Event__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
grasping_msgs__action__GraspPlanning_GetResult_Event__Sequence__are_equal(const grasping_msgs__action__GraspPlanning_GetResult_Event__Sequence * lhs, const grasping_msgs__action__GraspPlanning_GetResult_Event__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!grasping_msgs__action__GraspPlanning_GetResult_Event__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
grasping_msgs__action__GraspPlanning_GetResult_Event__Sequence__copy(
  const grasping_msgs__action__GraspPlanning_GetResult_Event__Sequence * input,
  grasping_msgs__action__GraspPlanning_GetResult_Event__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(grasping_msgs__action__GraspPlanning_GetResult_Event);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    grasping_msgs__action__GraspPlanning_GetResult_Event * data =
      (grasping_msgs__action__GraspPlanning_GetResult_Event *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!grasping_msgs__action__GraspPlanning_GetResult_Event__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          grasping_msgs__action__GraspPlanning_GetResult_Event__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!grasping_msgs__action__GraspPlanning_GetResult_Event__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `goal_id`
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__functions.h"
// Member `feedback`
// already included above
// #include "grasping_msgs/action/detail/grasp_planning__functions.h"

bool
grasping_msgs__action__GraspPlanning_FeedbackMessage__init(grasping_msgs__action__GraspPlanning_FeedbackMessage * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    grasping_msgs__action__GraspPlanning_FeedbackMessage__fini(msg);
    return false;
  }
  // feedback
  if (!grasping_msgs__action__GraspPlanning_Feedback__init(&msg->feedback)) {
    grasping_msgs__action__GraspPlanning_FeedbackMessage__fini(msg);
    return false;
  }
  return true;
}

void
grasping_msgs__action__GraspPlanning_FeedbackMessage__fini(grasping_msgs__action__GraspPlanning_FeedbackMessage * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
  // feedback
  grasping_msgs__action__GraspPlanning_Feedback__fini(&msg->feedback);
}

bool
grasping_msgs__action__GraspPlanning_FeedbackMessage__are_equal(const grasping_msgs__action__GraspPlanning_FeedbackMessage * lhs, const grasping_msgs__action__GraspPlanning_FeedbackMessage * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__are_equal(
      &(lhs->goal_id), &(rhs->goal_id)))
  {
    return false;
  }
  // feedback
  if (!grasping_msgs__action__GraspPlanning_Feedback__are_equal(
      &(lhs->feedback), &(rhs->feedback)))
  {
    return false;
  }
  return true;
}

bool
grasping_msgs__action__GraspPlanning_FeedbackMessage__copy(
  const grasping_msgs__action__GraspPlanning_FeedbackMessage * input,
  grasping_msgs__action__GraspPlanning_FeedbackMessage * output)
{
  if (!input || !output) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__copy(
      &(input->goal_id), &(output->goal_id)))
  {
    return false;
  }
  // feedback
  if (!grasping_msgs__action__GraspPlanning_Feedback__copy(
      &(input->feedback), &(output->feedback)))
  {
    return false;
  }
  return true;
}

grasping_msgs__action__GraspPlanning_FeedbackMessage *
grasping_msgs__action__GraspPlanning_FeedbackMessage__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_FeedbackMessage * msg = (grasping_msgs__action__GraspPlanning_FeedbackMessage *)allocator.allocate(sizeof(grasping_msgs__action__GraspPlanning_FeedbackMessage), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(grasping_msgs__action__GraspPlanning_FeedbackMessage));
  bool success = grasping_msgs__action__GraspPlanning_FeedbackMessage__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
grasping_msgs__action__GraspPlanning_FeedbackMessage__destroy(grasping_msgs__action__GraspPlanning_FeedbackMessage * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    grasping_msgs__action__GraspPlanning_FeedbackMessage__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
grasping_msgs__action__GraspPlanning_FeedbackMessage__Sequence__init(grasping_msgs__action__GraspPlanning_FeedbackMessage__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_FeedbackMessage * data = NULL;

  if (size) {
    data = (grasping_msgs__action__GraspPlanning_FeedbackMessage *)allocator.zero_allocate(size, sizeof(grasping_msgs__action__GraspPlanning_FeedbackMessage), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = grasping_msgs__action__GraspPlanning_FeedbackMessage__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        grasping_msgs__action__GraspPlanning_FeedbackMessage__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
grasping_msgs__action__GraspPlanning_FeedbackMessage__Sequence__fini(grasping_msgs__action__GraspPlanning_FeedbackMessage__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      grasping_msgs__action__GraspPlanning_FeedbackMessage__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

grasping_msgs__action__GraspPlanning_FeedbackMessage__Sequence *
grasping_msgs__action__GraspPlanning_FeedbackMessage__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__action__GraspPlanning_FeedbackMessage__Sequence * array = (grasping_msgs__action__GraspPlanning_FeedbackMessage__Sequence *)allocator.allocate(sizeof(grasping_msgs__action__GraspPlanning_FeedbackMessage__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = grasping_msgs__action__GraspPlanning_FeedbackMessage__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
grasping_msgs__action__GraspPlanning_FeedbackMessage__Sequence__destroy(grasping_msgs__action__GraspPlanning_FeedbackMessage__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    grasping_msgs__action__GraspPlanning_FeedbackMessage__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
grasping_msgs__action__GraspPlanning_FeedbackMessage__Sequence__are_equal(const grasping_msgs__action__GraspPlanning_FeedbackMessage__Sequence * lhs, const grasping_msgs__action__GraspPlanning_FeedbackMessage__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!grasping_msgs__action__GraspPlanning_FeedbackMessage__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
grasping_msgs__action__GraspPlanning_FeedbackMessage__Sequence__copy(
  const grasping_msgs__action__GraspPlanning_FeedbackMessage__Sequence * input,
  grasping_msgs__action__GraspPlanning_FeedbackMessage__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(grasping_msgs__action__GraspPlanning_FeedbackMessage);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    grasping_msgs__action__GraspPlanning_FeedbackMessage * data =
      (grasping_msgs__action__GraspPlanning_FeedbackMessage *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!grasping_msgs__action__GraspPlanning_FeedbackMessage__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          grasping_msgs__action__GraspPlanning_FeedbackMessage__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!grasping_msgs__action__GraspPlanning_FeedbackMessage__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
