// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from grasping_msgs:msg/GraspableObject.idl
// generated code does not contain a copyright notice
#include "grasping_msgs/msg/detail/graspable_object__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `object`
#include "grasping_msgs/msg/detail/object__functions.h"
// Member `grasps`
#include "moveit_msgs/msg/detail/grasp__functions.h"

bool
grasping_msgs__msg__GraspableObject__init(grasping_msgs__msg__GraspableObject * msg)
{
  if (!msg) {
    return false;
  }
  // object
  if (!grasping_msgs__msg__Object__init(&msg->object)) {
    grasping_msgs__msg__GraspableObject__fini(msg);
    return false;
  }
  // grasps
  if (!moveit_msgs__msg__Grasp__Sequence__init(&msg->grasps, 0)) {
    grasping_msgs__msg__GraspableObject__fini(msg);
    return false;
  }
  return true;
}

void
grasping_msgs__msg__GraspableObject__fini(grasping_msgs__msg__GraspableObject * msg)
{
  if (!msg) {
    return;
  }
  // object
  grasping_msgs__msg__Object__fini(&msg->object);
  // grasps
  moveit_msgs__msg__Grasp__Sequence__fini(&msg->grasps);
}

bool
grasping_msgs__msg__GraspableObject__are_equal(const grasping_msgs__msg__GraspableObject * lhs, const grasping_msgs__msg__GraspableObject * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // object
  if (!grasping_msgs__msg__Object__are_equal(
      &(lhs->object), &(rhs->object)))
  {
    return false;
  }
  // grasps
  if (!moveit_msgs__msg__Grasp__Sequence__are_equal(
      &(lhs->grasps), &(rhs->grasps)))
  {
    return false;
  }
  return true;
}

bool
grasping_msgs__msg__GraspableObject__copy(
  const grasping_msgs__msg__GraspableObject * input,
  grasping_msgs__msg__GraspableObject * output)
{
  if (!input || !output) {
    return false;
  }
  // object
  if (!grasping_msgs__msg__Object__copy(
      &(input->object), &(output->object)))
  {
    return false;
  }
  // grasps
  if (!moveit_msgs__msg__Grasp__Sequence__copy(
      &(input->grasps), &(output->grasps)))
  {
    return false;
  }
  return true;
}

grasping_msgs__msg__GraspableObject *
grasping_msgs__msg__GraspableObject__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__msg__GraspableObject * msg = (grasping_msgs__msg__GraspableObject *)allocator.allocate(sizeof(grasping_msgs__msg__GraspableObject), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(grasping_msgs__msg__GraspableObject));
  bool success = grasping_msgs__msg__GraspableObject__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
grasping_msgs__msg__GraspableObject__destroy(grasping_msgs__msg__GraspableObject * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    grasping_msgs__msg__GraspableObject__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
grasping_msgs__msg__GraspableObject__Sequence__init(grasping_msgs__msg__GraspableObject__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__msg__GraspableObject * data = NULL;

  if (size) {
    data = (grasping_msgs__msg__GraspableObject *)allocator.zero_allocate(size, sizeof(grasping_msgs__msg__GraspableObject), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = grasping_msgs__msg__GraspableObject__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        grasping_msgs__msg__GraspableObject__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
grasping_msgs__msg__GraspableObject__Sequence__fini(grasping_msgs__msg__GraspableObject__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      grasping_msgs__msg__GraspableObject__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

grasping_msgs__msg__GraspableObject__Sequence *
grasping_msgs__msg__GraspableObject__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__msg__GraspableObject__Sequence * array = (grasping_msgs__msg__GraspableObject__Sequence *)allocator.allocate(sizeof(grasping_msgs__msg__GraspableObject__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = grasping_msgs__msg__GraspableObject__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
grasping_msgs__msg__GraspableObject__Sequence__destroy(grasping_msgs__msg__GraspableObject__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    grasping_msgs__msg__GraspableObject__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
grasping_msgs__msg__GraspableObject__Sequence__are_equal(const grasping_msgs__msg__GraspableObject__Sequence * lhs, const grasping_msgs__msg__GraspableObject__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!grasping_msgs__msg__GraspableObject__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
grasping_msgs__msg__GraspableObject__Sequence__copy(
  const grasping_msgs__msg__GraspableObject__Sequence * input,
  grasping_msgs__msg__GraspableObject__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(grasping_msgs__msg__GraspableObject);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    grasping_msgs__msg__GraspableObject * data =
      (grasping_msgs__msg__GraspableObject *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!grasping_msgs__msg__GraspableObject__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          grasping_msgs__msg__GraspableObject__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!grasping_msgs__msg__GraspableObject__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
