// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from grasping_msgs:msg/GraspableObject.idl
// generated code does not contain a copyright notice

#ifndef GRASPING_MSGS__MSG__DETAIL__GRASPABLE_OBJECT__FUNCTIONS_H_
#define GRASPING_MSGS__MSG__DETAIL__GRASPABLE_OBJECT__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/action_type_support_struct.h"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_runtime_c/service_type_support_struct.h"
#include "rosidl_runtime_c/type_description/type_description__struct.h"
#include "rosidl_runtime_c/type_description/type_source__struct.h"
#include "rosidl_runtime_c/type_hash.h"
#include "rosidl_runtime_c/visibility_control.h"
#include "grasping_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "grasping_msgs/msg/detail/graspable_object__struct.h"

/// Initialize msg/GraspableObject message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * grasping_msgs__msg__GraspableObject
 * )) before or use
 * grasping_msgs__msg__GraspableObject__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_grasping_msgs
bool
grasping_msgs__msg__GraspableObject__init(grasping_msgs__msg__GraspableObject * msg);

/// Finalize msg/GraspableObject message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grasping_msgs
void
grasping_msgs__msg__GraspableObject__fini(grasping_msgs__msg__GraspableObject * msg);

/// Create msg/GraspableObject message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * grasping_msgs__msg__GraspableObject__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_grasping_msgs
grasping_msgs__msg__GraspableObject *
grasping_msgs__msg__GraspableObject__create();

/// Destroy msg/GraspableObject message.
/**
 * It calls
 * grasping_msgs__msg__GraspableObject__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grasping_msgs
void
grasping_msgs__msg__GraspableObject__destroy(grasping_msgs__msg__GraspableObject * msg);

/// Check for msg/GraspableObject message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_grasping_msgs
bool
grasping_msgs__msg__GraspableObject__are_equal(const grasping_msgs__msg__GraspableObject * lhs, const grasping_msgs__msg__GraspableObject * rhs);

/// Copy a msg/GraspableObject message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_grasping_msgs
bool
grasping_msgs__msg__GraspableObject__copy(
  const grasping_msgs__msg__GraspableObject * input,
  grasping_msgs__msg__GraspableObject * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_grasping_msgs
const rosidl_type_hash_t *
grasping_msgs__msg__GraspableObject__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_grasping_msgs
const rosidl_runtime_c__type_description__TypeDescription *
grasping_msgs__msg__GraspableObject__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_grasping_msgs
const rosidl_runtime_c__type_description__TypeSource *
grasping_msgs__msg__GraspableObject__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_grasping_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
grasping_msgs__msg__GraspableObject__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of msg/GraspableObject messages.
/**
 * It allocates the memory for the number of elements and calls
 * grasping_msgs__msg__GraspableObject__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_grasping_msgs
bool
grasping_msgs__msg__GraspableObject__Sequence__init(grasping_msgs__msg__GraspableObject__Sequence * array, size_t size);

/// Finalize array of msg/GraspableObject messages.
/**
 * It calls
 * grasping_msgs__msg__GraspableObject__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grasping_msgs
void
grasping_msgs__msg__GraspableObject__Sequence__fini(grasping_msgs__msg__GraspableObject__Sequence * array);

/// Create array of msg/GraspableObject messages.
/**
 * It allocates the memory for the array and calls
 * grasping_msgs__msg__GraspableObject__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_grasping_msgs
grasping_msgs__msg__GraspableObject__Sequence *
grasping_msgs__msg__GraspableObject__Sequence__create(size_t size);

/// Destroy array of msg/GraspableObject messages.
/**
 * It calls
 * grasping_msgs__msg__GraspableObject__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grasping_msgs
void
grasping_msgs__msg__GraspableObject__Sequence__destroy(grasping_msgs__msg__GraspableObject__Sequence * array);

/// Check for msg/GraspableObject message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_grasping_msgs
bool
grasping_msgs__msg__GraspableObject__Sequence__are_equal(const grasping_msgs__msg__GraspableObject__Sequence * lhs, const grasping_msgs__msg__GraspableObject__Sequence * rhs);

/// Copy an array of msg/GraspableObject messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_grasping_msgs
bool
grasping_msgs__msg__GraspableObject__Sequence__copy(
  const grasping_msgs__msg__GraspableObject__Sequence * input,
  grasping_msgs__msg__GraspableObject__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // GRASPING_MSGS__MSG__DETAIL__GRASPABLE_OBJECT__FUNCTIONS_H_
