// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from grasping_msgs:msg/GraspableObject.idl
// generated code does not contain a copyright notice

#ifndef GRASPING_MSGS__MSG__DETAIL__GRASPABLE_OBJECT__TRAITS_HPP_
#define GRASPING_MSGS__MSG__DETAIL__GRASPABLE_OBJECT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "grasping_msgs/msg/detail/graspable_object__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'object'
#include "grasping_msgs/msg/detail/object__traits.hpp"
// Member 'grasps'
#include "moveit_msgs/msg/detail/grasp__traits.hpp"

namespace grasping_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const GraspableObject & msg,
  std::ostream & out)
{
  out << "{";
  // member: object
  {
    out << "object: ";
    to_flow_style_yaml(msg.object, out);
    out << ", ";
  }

  // member: grasps
  {
    if (msg.grasps.size() == 0) {
      out << "grasps: []";
    } else {
      out << "grasps: [";
      size_t pending_items = msg.grasps.size();
      for (auto item : msg.grasps) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GraspableObject & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: object
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "object:\n";
    to_block_style_yaml(msg.object, out, indentation + 2);
  }

  // member: grasps
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.grasps.size() == 0) {
      out << "grasps: []\n";
    } else {
      out << "grasps:\n";
      for (auto item : msg.grasps) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GraspableObject & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace grasping_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grasping_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grasping_msgs::msg::GraspableObject & msg,
  std::ostream & out, size_t indentation = 0)
{
  grasping_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grasping_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const grasping_msgs::msg::GraspableObject & msg)
{
  return grasping_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<grasping_msgs::msg::GraspableObject>()
{
  return "grasping_msgs::msg::GraspableObject";
}

template<>
inline const char * name<grasping_msgs::msg::GraspableObject>()
{
  return "grasping_msgs/msg/GraspableObject";
}

template<>
struct has_fixed_size<grasping_msgs::msg::GraspableObject>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<grasping_msgs::msg::GraspableObject>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<grasping_msgs::msg::GraspableObject>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // GRASPING_MSGS__MSG__DETAIL__GRASPABLE_OBJECT__TRAITS_HPP_
