// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from grasping_msgs:msg/Object.idl
// generated code does not contain a copyright notice

#ifndef GRASPING_MSGS__MSG__DETAIL__OBJECT__TRAITS_HPP_
#define GRASPING_MSGS__MSG__DETAIL__OBJECT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "grasping_msgs/msg/detail/object__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'properties'
#include "grasping_msgs/msg/detail/object_property__traits.hpp"
// Member 'point_cluster'
#include "sensor_msgs/msg/detail/point_cloud2__traits.hpp"
// Member 'primitives'
#include "shape_msgs/msg/detail/solid_primitive__traits.hpp"
// Member 'primitive_poses'
// Member 'mesh_poses'
#include "geometry_msgs/msg/detail/pose__traits.hpp"
// Member 'meshes'
#include "shape_msgs/msg/detail/mesh__traits.hpp"
// Member 'surface'
#include "shape_msgs/msg/detail/plane__traits.hpp"

namespace grasping_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Object & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: name
  {
    out << "name: ";
    rosidl_generator_traits::value_to_yaml(msg.name, out);
    out << ", ";
  }

  // member: support_surface
  {
    out << "support_surface: ";
    rosidl_generator_traits::value_to_yaml(msg.support_surface, out);
    out << ", ";
  }

  // member: properties
  {
    if (msg.properties.size() == 0) {
      out << "properties: []";
    } else {
      out << "properties: [";
      size_t pending_items = msg.properties.size();
      for (auto item : msg.properties) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: point_cluster
  {
    out << "point_cluster: ";
    to_flow_style_yaml(msg.point_cluster, out);
    out << ", ";
  }

  // member: primitives
  {
    if (msg.primitives.size() == 0) {
      out << "primitives: []";
    } else {
      out << "primitives: [";
      size_t pending_items = msg.primitives.size();
      for (auto item : msg.primitives) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: primitive_poses
  {
    if (msg.primitive_poses.size() == 0) {
      out << "primitive_poses: []";
    } else {
      out << "primitive_poses: [";
      size_t pending_items = msg.primitive_poses.size();
      for (auto item : msg.primitive_poses) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: meshes
  {
    if (msg.meshes.size() == 0) {
      out << "meshes: []";
    } else {
      out << "meshes: [";
      size_t pending_items = msg.meshes.size();
      for (auto item : msg.meshes) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: mesh_poses
  {
    if (msg.mesh_poses.size() == 0) {
      out << "mesh_poses: []";
    } else {
      out << "mesh_poses: [";
      size_t pending_items = msg.mesh_poses.size();
      for (auto item : msg.mesh_poses) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: surface
  {
    out << "surface: ";
    to_flow_style_yaml(msg.surface, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Object & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "name: ";
    rosidl_generator_traits::value_to_yaml(msg.name, out);
    out << "\n";
  }

  // member: support_surface
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "support_surface: ";
    rosidl_generator_traits::value_to_yaml(msg.support_surface, out);
    out << "\n";
  }

  // member: properties
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.properties.size() == 0) {
      out << "properties: []\n";
    } else {
      out << "properties:\n";
      for (auto item : msg.properties) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: point_cluster
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "point_cluster:\n";
    to_block_style_yaml(msg.point_cluster, out, indentation + 2);
  }

  // member: primitives
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.primitives.size() == 0) {
      out << "primitives: []\n";
    } else {
      out << "primitives:\n";
      for (auto item : msg.primitives) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: primitive_poses
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.primitive_poses.size() == 0) {
      out << "primitive_poses: []\n";
    } else {
      out << "primitive_poses:\n";
      for (auto item : msg.primitive_poses) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: meshes
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.meshes.size() == 0) {
      out << "meshes: []\n";
    } else {
      out << "meshes:\n";
      for (auto item : msg.meshes) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: mesh_poses
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.mesh_poses.size() == 0) {
      out << "mesh_poses: []\n";
    } else {
      out << "mesh_poses:\n";
      for (auto item : msg.mesh_poses) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: surface
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "surface:\n";
    to_block_style_yaml(msg.surface, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Object & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace grasping_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grasping_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grasping_msgs::msg::Object & msg,
  std::ostream & out, size_t indentation = 0)
{
  grasping_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grasping_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const grasping_msgs::msg::Object & msg)
{
  return grasping_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<grasping_msgs::msg::Object>()
{
  return "grasping_msgs::msg::Object";
}

template<>
inline const char * name<grasping_msgs::msg::Object>()
{
  return "grasping_msgs/msg/Object";
}

template<>
struct has_fixed_size<grasping_msgs::msg::Object>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<grasping_msgs::msg::Object>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<grasping_msgs::msg::Object>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // GRASPING_MSGS__MSG__DETAIL__OBJECT__TRAITS_HPP_
