// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from grasping_msgs:msg/ObjectProperty.idl
// generated code does not contain a copyright notice
#include "grasping_msgs/msg/detail/object_property__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `name`
// Member `value`
#include "rosidl_runtime_c/string_functions.h"

bool
grasping_msgs__msg__ObjectProperty__init(grasping_msgs__msg__ObjectProperty * msg)
{
  if (!msg) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__init(&msg->name)) {
    grasping_msgs__msg__ObjectProperty__fini(msg);
    return false;
  }
  // value
  if (!rosidl_runtime_c__String__init(&msg->value)) {
    grasping_msgs__msg__ObjectProperty__fini(msg);
    return false;
  }
  return true;
}

void
grasping_msgs__msg__ObjectProperty__fini(grasping_msgs__msg__ObjectProperty * msg)
{
  if (!msg) {
    return;
  }
  // name
  rosidl_runtime_c__String__fini(&msg->name);
  // value
  rosidl_runtime_c__String__fini(&msg->value);
}

bool
grasping_msgs__msg__ObjectProperty__are_equal(const grasping_msgs__msg__ObjectProperty * lhs, const grasping_msgs__msg__ObjectProperty * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->name), &(rhs->name)))
  {
    return false;
  }
  // value
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->value), &(rhs->value)))
  {
    return false;
  }
  return true;
}

bool
grasping_msgs__msg__ObjectProperty__copy(
  const grasping_msgs__msg__ObjectProperty * input,
  grasping_msgs__msg__ObjectProperty * output)
{
  if (!input || !output) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__copy(
      &(input->name), &(output->name)))
  {
    return false;
  }
  // value
  if (!rosidl_runtime_c__String__copy(
      &(input->value), &(output->value)))
  {
    return false;
  }
  return true;
}

grasping_msgs__msg__ObjectProperty *
grasping_msgs__msg__ObjectProperty__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__msg__ObjectProperty * msg = (grasping_msgs__msg__ObjectProperty *)allocator.allocate(sizeof(grasping_msgs__msg__ObjectProperty), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(grasping_msgs__msg__ObjectProperty));
  bool success = grasping_msgs__msg__ObjectProperty__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
grasping_msgs__msg__ObjectProperty__destroy(grasping_msgs__msg__ObjectProperty * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    grasping_msgs__msg__ObjectProperty__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
grasping_msgs__msg__ObjectProperty__Sequence__init(grasping_msgs__msg__ObjectProperty__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__msg__ObjectProperty * data = NULL;

  if (size) {
    data = (grasping_msgs__msg__ObjectProperty *)allocator.zero_allocate(size, sizeof(grasping_msgs__msg__ObjectProperty), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = grasping_msgs__msg__ObjectProperty__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        grasping_msgs__msg__ObjectProperty__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
grasping_msgs__msg__ObjectProperty__Sequence__fini(grasping_msgs__msg__ObjectProperty__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      grasping_msgs__msg__ObjectProperty__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

grasping_msgs__msg__ObjectProperty__Sequence *
grasping_msgs__msg__ObjectProperty__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__msg__ObjectProperty__Sequence * array = (grasping_msgs__msg__ObjectProperty__Sequence *)allocator.allocate(sizeof(grasping_msgs__msg__ObjectProperty__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = grasping_msgs__msg__ObjectProperty__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
grasping_msgs__msg__ObjectProperty__Sequence__destroy(grasping_msgs__msg__ObjectProperty__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    grasping_msgs__msg__ObjectProperty__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
grasping_msgs__msg__ObjectProperty__Sequence__are_equal(const grasping_msgs__msg__ObjectProperty__Sequence * lhs, const grasping_msgs__msg__ObjectProperty__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!grasping_msgs__msg__ObjectProperty__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
grasping_msgs__msg__ObjectProperty__Sequence__copy(
  const grasping_msgs__msg__ObjectProperty__Sequence * input,
  grasping_msgs__msg__ObjectProperty__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(grasping_msgs__msg__ObjectProperty);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    grasping_msgs__msg__ObjectProperty * data =
      (grasping_msgs__msg__ObjectProperty *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!grasping_msgs__msg__ObjectProperty__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          grasping_msgs__msg__ObjectProperty__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!grasping_msgs__msg__ObjectProperty__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
