// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from grasping_msgs:action/FindGraspableObjects.idl
// generated code does not contain a copyright notice

#ifndef GRASPING_MSGS__ACTION__DETAIL__FIND_GRASPABLE_OBJECTS__TRAITS_HPP_
#define GRASPING_MSGS__ACTION__DETAIL__FIND_GRASPABLE_OBJECTS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "grasping_msgs/action/detail/find_graspable_objects__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace grasping_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const FindGraspableObjects_Goal & msg,
  std::ostream & out)
{
  out << "{";
  // member: plan_grasps
  {
    out << "plan_grasps: ";
    rosidl_generator_traits::value_to_yaml(msg.plan_grasps, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const FindGraspableObjects_Goal & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: plan_grasps
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "plan_grasps: ";
    rosidl_generator_traits::value_to_yaml(msg.plan_grasps, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const FindGraspableObjects_Goal & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace grasping_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grasping_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grasping_msgs::action::FindGraspableObjects_Goal & msg,
  std::ostream & out, size_t indentation = 0)
{
  grasping_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grasping_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const grasping_msgs::action::FindGraspableObjects_Goal & msg)
{
  return grasping_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<grasping_msgs::action::FindGraspableObjects_Goal>()
{
  return "grasping_msgs::action::FindGraspableObjects_Goal";
}

template<>
inline const char * name<grasping_msgs::action::FindGraspableObjects_Goal>()
{
  return "grasping_msgs/action/FindGraspableObjects_Goal";
}

template<>
struct has_fixed_size<grasping_msgs::action::FindGraspableObjects_Goal>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<grasping_msgs::action::FindGraspableObjects_Goal>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<grasping_msgs::action::FindGraspableObjects_Goal>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'objects'
#include "grasping_msgs/msg/detail/graspable_object__traits.hpp"
// Member 'support_surfaces'
#include "grasping_msgs/msg/detail/object__traits.hpp"

namespace grasping_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const FindGraspableObjects_Result & msg,
  std::ostream & out)
{
  out << "{";
  // member: objects
  {
    if (msg.objects.size() == 0) {
      out << "objects: []";
    } else {
      out << "objects: [";
      size_t pending_items = msg.objects.size();
      for (auto item : msg.objects) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: support_surfaces
  {
    if (msg.support_surfaces.size() == 0) {
      out << "support_surfaces: []";
    } else {
      out << "support_surfaces: [";
      size_t pending_items = msg.support_surfaces.size();
      for (auto item : msg.support_surfaces) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const FindGraspableObjects_Result & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: objects
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.objects.size() == 0) {
      out << "objects: []\n";
    } else {
      out << "objects:\n";
      for (auto item : msg.objects) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: support_surfaces
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.support_surfaces.size() == 0) {
      out << "support_surfaces: []\n";
    } else {
      out << "support_surfaces:\n";
      for (auto item : msg.support_surfaces) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const FindGraspableObjects_Result & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace grasping_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grasping_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grasping_msgs::action::FindGraspableObjects_Result & msg,
  std::ostream & out, size_t indentation = 0)
{
  grasping_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grasping_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const grasping_msgs::action::FindGraspableObjects_Result & msg)
{
  return grasping_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<grasping_msgs::action::FindGraspableObjects_Result>()
{
  return "grasping_msgs::action::FindGraspableObjects_Result";
}

template<>
inline const char * name<grasping_msgs::action::FindGraspableObjects_Result>()
{
  return "grasping_msgs/action/FindGraspableObjects_Result";
}

template<>
struct has_fixed_size<grasping_msgs::action::FindGraspableObjects_Result>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<grasping_msgs::action::FindGraspableObjects_Result>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<grasping_msgs::action::FindGraspableObjects_Result>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'object'
// already included above
// #include "grasping_msgs/msg/detail/graspable_object__traits.hpp"

namespace grasping_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const FindGraspableObjects_Feedback & msg,
  std::ostream & out)
{
  out << "{";
  // member: object
  {
    out << "object: ";
    to_flow_style_yaml(msg.object, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const FindGraspableObjects_Feedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: object
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "object:\n";
    to_block_style_yaml(msg.object, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const FindGraspableObjects_Feedback & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace grasping_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grasping_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grasping_msgs::action::FindGraspableObjects_Feedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  grasping_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grasping_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const grasping_msgs::action::FindGraspableObjects_Feedback & msg)
{
  return grasping_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<grasping_msgs::action::FindGraspableObjects_Feedback>()
{
  return "grasping_msgs::action::FindGraspableObjects_Feedback";
}

template<>
inline const char * name<grasping_msgs::action::FindGraspableObjects_Feedback>()
{
  return "grasping_msgs/action/FindGraspableObjects_Feedback";
}

template<>
struct has_fixed_size<grasping_msgs::action::FindGraspableObjects_Feedback>
  : std::integral_constant<bool, has_fixed_size<grasping_msgs::msg::GraspableObject>::value> {};

template<>
struct has_bounded_size<grasping_msgs::action::FindGraspableObjects_Feedback>
  : std::integral_constant<bool, has_bounded_size<grasping_msgs::msg::GraspableObject>::value> {};

template<>
struct is_message<grasping_msgs::action::FindGraspableObjects_Feedback>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'goal'
#include "grasping_msgs/action/detail/find_graspable_objects__traits.hpp"

namespace grasping_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const FindGraspableObjects_SendGoal_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
    out << ", ";
  }

  // member: goal
  {
    out << "goal: ";
    to_flow_style_yaml(msg.goal, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const FindGraspableObjects_SendGoal_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: goal
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal:\n";
    to_block_style_yaml(msg.goal, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const FindGraspableObjects_SendGoal_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace grasping_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grasping_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grasping_msgs::action::FindGraspableObjects_SendGoal_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  grasping_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grasping_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const grasping_msgs::action::FindGraspableObjects_SendGoal_Request & msg)
{
  return grasping_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<grasping_msgs::action::FindGraspableObjects_SendGoal_Request>()
{
  return "grasping_msgs::action::FindGraspableObjects_SendGoal_Request";
}

template<>
inline const char * name<grasping_msgs::action::FindGraspableObjects_SendGoal_Request>()
{
  return "grasping_msgs/action/FindGraspableObjects_SendGoal_Request";
}

template<>
struct has_fixed_size<grasping_msgs::action::FindGraspableObjects_SendGoal_Request>
  : std::integral_constant<bool, has_fixed_size<grasping_msgs::action::FindGraspableObjects_Goal>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<grasping_msgs::action::FindGraspableObjects_SendGoal_Request>
  : std::integral_constant<bool, has_bounded_size<grasping_msgs::action::FindGraspableObjects_Goal>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<grasping_msgs::action::FindGraspableObjects_SendGoal_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace grasping_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const FindGraspableObjects_SendGoal_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: accepted
  {
    out << "accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.accepted, out);
    out << ", ";
  }

  // member: stamp
  {
    out << "stamp: ";
    to_flow_style_yaml(msg.stamp, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const FindGraspableObjects_SendGoal_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: accepted
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.accepted, out);
    out << "\n";
  }

  // member: stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stamp:\n";
    to_block_style_yaml(msg.stamp, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const FindGraspableObjects_SendGoal_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace grasping_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grasping_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grasping_msgs::action::FindGraspableObjects_SendGoal_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  grasping_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grasping_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const grasping_msgs::action::FindGraspableObjects_SendGoal_Response & msg)
{
  return grasping_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<grasping_msgs::action::FindGraspableObjects_SendGoal_Response>()
{
  return "grasping_msgs::action::FindGraspableObjects_SendGoal_Response";
}

template<>
inline const char * name<grasping_msgs::action::FindGraspableObjects_SendGoal_Response>()
{
  return "grasping_msgs/action/FindGraspableObjects_SendGoal_Response";
}

template<>
struct has_fixed_size<grasping_msgs::action::FindGraspableObjects_SendGoal_Response>
  : std::integral_constant<bool, has_fixed_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct has_bounded_size<grasping_msgs::action::FindGraspableObjects_SendGoal_Response>
  : std::integral_constant<bool, has_bounded_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct is_message<grasping_msgs::action::FindGraspableObjects_SendGoal_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace grasping_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const FindGraspableObjects_SendGoal_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const FindGraspableObjects_SendGoal_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const FindGraspableObjects_SendGoal_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace grasping_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grasping_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grasping_msgs::action::FindGraspableObjects_SendGoal_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  grasping_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grasping_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const grasping_msgs::action::FindGraspableObjects_SendGoal_Event & msg)
{
  return grasping_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<grasping_msgs::action::FindGraspableObjects_SendGoal_Event>()
{
  return "grasping_msgs::action::FindGraspableObjects_SendGoal_Event";
}

template<>
inline const char * name<grasping_msgs::action::FindGraspableObjects_SendGoal_Event>()
{
  return "grasping_msgs/action/FindGraspableObjects_SendGoal_Event";
}

template<>
struct has_fixed_size<grasping_msgs::action::FindGraspableObjects_SendGoal_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<grasping_msgs::action::FindGraspableObjects_SendGoal_Event>
  : std::integral_constant<bool, has_bounded_size<grasping_msgs::action::FindGraspableObjects_SendGoal_Request>::value && has_bounded_size<grasping_msgs::action::FindGraspableObjects_SendGoal_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<grasping_msgs::action::FindGraspableObjects_SendGoal_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<grasping_msgs::action::FindGraspableObjects_SendGoal>()
{
  return "grasping_msgs::action::FindGraspableObjects_SendGoal";
}

template<>
inline const char * name<grasping_msgs::action::FindGraspableObjects_SendGoal>()
{
  return "grasping_msgs/action/FindGraspableObjects_SendGoal";
}

template<>
struct has_fixed_size<grasping_msgs::action::FindGraspableObjects_SendGoal>
  : std::integral_constant<
    bool,
    has_fixed_size<grasping_msgs::action::FindGraspableObjects_SendGoal_Request>::value &&
    has_fixed_size<grasping_msgs::action::FindGraspableObjects_SendGoal_Response>::value
  >
{
};

template<>
struct has_bounded_size<grasping_msgs::action::FindGraspableObjects_SendGoal>
  : std::integral_constant<
    bool,
    has_bounded_size<grasping_msgs::action::FindGraspableObjects_SendGoal_Request>::value &&
    has_bounded_size<grasping_msgs::action::FindGraspableObjects_SendGoal_Response>::value
  >
{
};

template<>
struct is_service<grasping_msgs::action::FindGraspableObjects_SendGoal>
  : std::true_type
{
};

template<>
struct is_service_request<grasping_msgs::action::FindGraspableObjects_SendGoal_Request>
  : std::true_type
{
};

template<>
struct is_service_response<grasping_msgs::action::FindGraspableObjects_SendGoal_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"

namespace grasping_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const FindGraspableObjects_GetResult_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const FindGraspableObjects_GetResult_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const FindGraspableObjects_GetResult_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace grasping_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grasping_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grasping_msgs::action::FindGraspableObjects_GetResult_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  grasping_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grasping_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const grasping_msgs::action::FindGraspableObjects_GetResult_Request & msg)
{
  return grasping_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<grasping_msgs::action::FindGraspableObjects_GetResult_Request>()
{
  return "grasping_msgs::action::FindGraspableObjects_GetResult_Request";
}

template<>
inline const char * name<grasping_msgs::action::FindGraspableObjects_GetResult_Request>()
{
  return "grasping_msgs/action/FindGraspableObjects_GetResult_Request";
}

template<>
struct has_fixed_size<grasping_msgs::action::FindGraspableObjects_GetResult_Request>
  : std::integral_constant<bool, has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<grasping_msgs::action::FindGraspableObjects_GetResult_Request>
  : std::integral_constant<bool, has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<grasping_msgs::action::FindGraspableObjects_GetResult_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'result'
// already included above
// #include "grasping_msgs/action/detail/find_graspable_objects__traits.hpp"

namespace grasping_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const FindGraspableObjects_GetResult_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: status
  {
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << ", ";
  }

  // member: result
  {
    out << "result: ";
    to_flow_style_yaml(msg.result, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const FindGraspableObjects_GetResult_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << "\n";
  }

  // member: result
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "result:\n";
    to_block_style_yaml(msg.result, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const FindGraspableObjects_GetResult_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace grasping_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grasping_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grasping_msgs::action::FindGraspableObjects_GetResult_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  grasping_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grasping_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const grasping_msgs::action::FindGraspableObjects_GetResult_Response & msg)
{
  return grasping_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<grasping_msgs::action::FindGraspableObjects_GetResult_Response>()
{
  return "grasping_msgs::action::FindGraspableObjects_GetResult_Response";
}

template<>
inline const char * name<grasping_msgs::action::FindGraspableObjects_GetResult_Response>()
{
  return "grasping_msgs/action/FindGraspableObjects_GetResult_Response";
}

template<>
struct has_fixed_size<grasping_msgs::action::FindGraspableObjects_GetResult_Response>
  : std::integral_constant<bool, has_fixed_size<grasping_msgs::action::FindGraspableObjects_Result>::value> {};

template<>
struct has_bounded_size<grasping_msgs::action::FindGraspableObjects_GetResult_Response>
  : std::integral_constant<bool, has_bounded_size<grasping_msgs::action::FindGraspableObjects_Result>::value> {};

template<>
struct is_message<grasping_msgs::action::FindGraspableObjects_GetResult_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
// already included above
// #include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace grasping_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const FindGraspableObjects_GetResult_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const FindGraspableObjects_GetResult_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const FindGraspableObjects_GetResult_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace grasping_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grasping_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grasping_msgs::action::FindGraspableObjects_GetResult_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  grasping_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grasping_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const grasping_msgs::action::FindGraspableObjects_GetResult_Event & msg)
{
  return grasping_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<grasping_msgs::action::FindGraspableObjects_GetResult_Event>()
{
  return "grasping_msgs::action::FindGraspableObjects_GetResult_Event";
}

template<>
inline const char * name<grasping_msgs::action::FindGraspableObjects_GetResult_Event>()
{
  return "grasping_msgs/action/FindGraspableObjects_GetResult_Event";
}

template<>
struct has_fixed_size<grasping_msgs::action::FindGraspableObjects_GetResult_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<grasping_msgs::action::FindGraspableObjects_GetResult_Event>
  : std::integral_constant<bool, has_bounded_size<grasping_msgs::action::FindGraspableObjects_GetResult_Request>::value && has_bounded_size<grasping_msgs::action::FindGraspableObjects_GetResult_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<grasping_msgs::action::FindGraspableObjects_GetResult_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<grasping_msgs::action::FindGraspableObjects_GetResult>()
{
  return "grasping_msgs::action::FindGraspableObjects_GetResult";
}

template<>
inline const char * name<grasping_msgs::action::FindGraspableObjects_GetResult>()
{
  return "grasping_msgs/action/FindGraspableObjects_GetResult";
}

template<>
struct has_fixed_size<grasping_msgs::action::FindGraspableObjects_GetResult>
  : std::integral_constant<
    bool,
    has_fixed_size<grasping_msgs::action::FindGraspableObjects_GetResult_Request>::value &&
    has_fixed_size<grasping_msgs::action::FindGraspableObjects_GetResult_Response>::value
  >
{
};

template<>
struct has_bounded_size<grasping_msgs::action::FindGraspableObjects_GetResult>
  : std::integral_constant<
    bool,
    has_bounded_size<grasping_msgs::action::FindGraspableObjects_GetResult_Request>::value &&
    has_bounded_size<grasping_msgs::action::FindGraspableObjects_GetResult_Response>::value
  >
{
};

template<>
struct is_service<grasping_msgs::action::FindGraspableObjects_GetResult>
  : std::true_type
{
};

template<>
struct is_service_request<grasping_msgs::action::FindGraspableObjects_GetResult_Request>
  : std::true_type
{
};

template<>
struct is_service_response<grasping_msgs::action::FindGraspableObjects_GetResult_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'feedback'
// already included above
// #include "grasping_msgs/action/detail/find_graspable_objects__traits.hpp"

namespace grasping_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const FindGraspableObjects_FeedbackMessage & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
    out << ", ";
  }

  // member: feedback
  {
    out << "feedback: ";
    to_flow_style_yaml(msg.feedback, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const FindGraspableObjects_FeedbackMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: feedback
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "feedback:\n";
    to_block_style_yaml(msg.feedback, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const FindGraspableObjects_FeedbackMessage & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace grasping_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grasping_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grasping_msgs::action::FindGraspableObjects_FeedbackMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  grasping_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grasping_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const grasping_msgs::action::FindGraspableObjects_FeedbackMessage & msg)
{
  return grasping_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<grasping_msgs::action::FindGraspableObjects_FeedbackMessage>()
{
  return "grasping_msgs::action::FindGraspableObjects_FeedbackMessage";
}

template<>
inline const char * name<grasping_msgs::action::FindGraspableObjects_FeedbackMessage>()
{
  return "grasping_msgs/action/FindGraspableObjects_FeedbackMessage";
}

template<>
struct has_fixed_size<grasping_msgs::action::FindGraspableObjects_FeedbackMessage>
  : std::integral_constant<bool, has_fixed_size<grasping_msgs::action::FindGraspableObjects_Feedback>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<grasping_msgs::action::FindGraspableObjects_FeedbackMessage>
  : std::integral_constant<bool, has_bounded_size<grasping_msgs::action::FindGraspableObjects_Feedback>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<grasping_msgs::action::FindGraspableObjects_FeedbackMessage>
  : std::true_type {};

}  // namespace rosidl_generator_traits


namespace rosidl_generator_traits
{

template<>
struct is_action<grasping_msgs::action::FindGraspableObjects>
  : std::true_type
{
};

template<>
struct is_action_goal<grasping_msgs::action::FindGraspableObjects_Goal>
  : std::true_type
{
};

template<>
struct is_action_result<grasping_msgs::action::FindGraspableObjects_Result>
  : std::true_type
{
};

template<>
struct is_action_feedback<grasping_msgs::action::FindGraspableObjects_Feedback>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits


#endif  // GRASPING_MSGS__ACTION__DETAIL__FIND_GRASPABLE_OBJECTS__TRAITS_HPP_
