// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from grasping_msgs:msg/Object.idl
// generated code does not contain a copyright notice
#include "grasping_msgs/msg/detail/object__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `name`
// Member `support_surface`
#include "rosidl_runtime_c/string_functions.h"
// Member `properties`
#include "grasping_msgs/msg/detail/object_property__functions.h"
// Member `point_cluster`
#include "sensor_msgs/msg/detail/point_cloud2__functions.h"
// Member `primitives`
#include "shape_msgs/msg/detail/solid_primitive__functions.h"
// Member `primitive_poses`
// Member `mesh_poses`
#include "geometry_msgs/msg/detail/pose__functions.h"
// Member `meshes`
#include "shape_msgs/msg/detail/mesh__functions.h"
// Member `surface`
#include "shape_msgs/msg/detail/plane__functions.h"

bool
grasping_msgs__msg__Object__init(grasping_msgs__msg__Object * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    grasping_msgs__msg__Object__fini(msg);
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__init(&msg->name)) {
    grasping_msgs__msg__Object__fini(msg);
    return false;
  }
  // support_surface
  if (!rosidl_runtime_c__String__init(&msg->support_surface)) {
    grasping_msgs__msg__Object__fini(msg);
    return false;
  }
  // properties
  if (!grasping_msgs__msg__ObjectProperty__Sequence__init(&msg->properties, 0)) {
    grasping_msgs__msg__Object__fini(msg);
    return false;
  }
  // point_cluster
  if (!sensor_msgs__msg__PointCloud2__init(&msg->point_cluster)) {
    grasping_msgs__msg__Object__fini(msg);
    return false;
  }
  // primitives
  if (!shape_msgs__msg__SolidPrimitive__Sequence__init(&msg->primitives, 0)) {
    grasping_msgs__msg__Object__fini(msg);
    return false;
  }
  // primitive_poses
  if (!geometry_msgs__msg__Pose__Sequence__init(&msg->primitive_poses, 0)) {
    grasping_msgs__msg__Object__fini(msg);
    return false;
  }
  // meshes
  if (!shape_msgs__msg__Mesh__Sequence__init(&msg->meshes, 0)) {
    grasping_msgs__msg__Object__fini(msg);
    return false;
  }
  // mesh_poses
  if (!geometry_msgs__msg__Pose__Sequence__init(&msg->mesh_poses, 0)) {
    grasping_msgs__msg__Object__fini(msg);
    return false;
  }
  // surface
  if (!shape_msgs__msg__Plane__init(&msg->surface)) {
    grasping_msgs__msg__Object__fini(msg);
    return false;
  }
  return true;
}

void
grasping_msgs__msg__Object__fini(grasping_msgs__msg__Object * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // name
  rosidl_runtime_c__String__fini(&msg->name);
  // support_surface
  rosidl_runtime_c__String__fini(&msg->support_surface);
  // properties
  grasping_msgs__msg__ObjectProperty__Sequence__fini(&msg->properties);
  // point_cluster
  sensor_msgs__msg__PointCloud2__fini(&msg->point_cluster);
  // primitives
  shape_msgs__msg__SolidPrimitive__Sequence__fini(&msg->primitives);
  // primitive_poses
  geometry_msgs__msg__Pose__Sequence__fini(&msg->primitive_poses);
  // meshes
  shape_msgs__msg__Mesh__Sequence__fini(&msg->meshes);
  // mesh_poses
  geometry_msgs__msg__Pose__Sequence__fini(&msg->mesh_poses);
  // surface
  shape_msgs__msg__Plane__fini(&msg->surface);
}

bool
grasping_msgs__msg__Object__are_equal(const grasping_msgs__msg__Object * lhs, const grasping_msgs__msg__Object * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->name), &(rhs->name)))
  {
    return false;
  }
  // support_surface
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->support_surface), &(rhs->support_surface)))
  {
    return false;
  }
  // properties
  if (!grasping_msgs__msg__ObjectProperty__Sequence__are_equal(
      &(lhs->properties), &(rhs->properties)))
  {
    return false;
  }
  // point_cluster
  if (!sensor_msgs__msg__PointCloud2__are_equal(
      &(lhs->point_cluster), &(rhs->point_cluster)))
  {
    return false;
  }
  // primitives
  if (!shape_msgs__msg__SolidPrimitive__Sequence__are_equal(
      &(lhs->primitives), &(rhs->primitives)))
  {
    return false;
  }
  // primitive_poses
  if (!geometry_msgs__msg__Pose__Sequence__are_equal(
      &(lhs->primitive_poses), &(rhs->primitive_poses)))
  {
    return false;
  }
  // meshes
  if (!shape_msgs__msg__Mesh__Sequence__are_equal(
      &(lhs->meshes), &(rhs->meshes)))
  {
    return false;
  }
  // mesh_poses
  if (!geometry_msgs__msg__Pose__Sequence__are_equal(
      &(lhs->mesh_poses), &(rhs->mesh_poses)))
  {
    return false;
  }
  // surface
  if (!shape_msgs__msg__Plane__are_equal(
      &(lhs->surface), &(rhs->surface)))
  {
    return false;
  }
  return true;
}

bool
grasping_msgs__msg__Object__copy(
  const grasping_msgs__msg__Object * input,
  grasping_msgs__msg__Object * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__copy(
      &(input->name), &(output->name)))
  {
    return false;
  }
  // support_surface
  if (!rosidl_runtime_c__String__copy(
      &(input->support_surface), &(output->support_surface)))
  {
    return false;
  }
  // properties
  if (!grasping_msgs__msg__ObjectProperty__Sequence__copy(
      &(input->properties), &(output->properties)))
  {
    return false;
  }
  // point_cluster
  if (!sensor_msgs__msg__PointCloud2__copy(
      &(input->point_cluster), &(output->point_cluster)))
  {
    return false;
  }
  // primitives
  if (!shape_msgs__msg__SolidPrimitive__Sequence__copy(
      &(input->primitives), &(output->primitives)))
  {
    return false;
  }
  // primitive_poses
  if (!geometry_msgs__msg__Pose__Sequence__copy(
      &(input->primitive_poses), &(output->primitive_poses)))
  {
    return false;
  }
  // meshes
  if (!shape_msgs__msg__Mesh__Sequence__copy(
      &(input->meshes), &(output->meshes)))
  {
    return false;
  }
  // mesh_poses
  if (!geometry_msgs__msg__Pose__Sequence__copy(
      &(input->mesh_poses), &(output->mesh_poses)))
  {
    return false;
  }
  // surface
  if (!shape_msgs__msg__Plane__copy(
      &(input->surface), &(output->surface)))
  {
    return false;
  }
  return true;
}

grasping_msgs__msg__Object *
grasping_msgs__msg__Object__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__msg__Object * msg = (grasping_msgs__msg__Object *)allocator.allocate(sizeof(grasping_msgs__msg__Object), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(grasping_msgs__msg__Object));
  bool success = grasping_msgs__msg__Object__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
grasping_msgs__msg__Object__destroy(grasping_msgs__msg__Object * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    grasping_msgs__msg__Object__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
grasping_msgs__msg__Object__Sequence__init(grasping_msgs__msg__Object__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__msg__Object * data = NULL;

  if (size) {
    data = (grasping_msgs__msg__Object *)allocator.zero_allocate(size, sizeof(grasping_msgs__msg__Object), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = grasping_msgs__msg__Object__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        grasping_msgs__msg__Object__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
grasping_msgs__msg__Object__Sequence__fini(grasping_msgs__msg__Object__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      grasping_msgs__msg__Object__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

grasping_msgs__msg__Object__Sequence *
grasping_msgs__msg__Object__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grasping_msgs__msg__Object__Sequence * array = (grasping_msgs__msg__Object__Sequence *)allocator.allocate(sizeof(grasping_msgs__msg__Object__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = grasping_msgs__msg__Object__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
grasping_msgs__msg__Object__Sequence__destroy(grasping_msgs__msg__Object__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    grasping_msgs__msg__Object__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
grasping_msgs__msg__Object__Sequence__are_equal(const grasping_msgs__msg__Object__Sequence * lhs, const grasping_msgs__msg__Object__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!grasping_msgs__msg__Object__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
grasping_msgs__msg__Object__Sequence__copy(
  const grasping_msgs__msg__Object__Sequence * input,
  grasping_msgs__msg__Object__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(grasping_msgs__msg__Object);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    grasping_msgs__msg__Object * data =
      (grasping_msgs__msg__Object *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!grasping_msgs__msg__Object__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          grasping_msgs__msg__Object__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!grasping_msgs__msg__Object__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
