// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from grasping_msgs:msg/ObjectProperty.idl
// generated code does not contain a copyright notice

#ifndef GRASPING_MSGS__MSG__DETAIL__OBJECT_PROPERTY__TRAITS_HPP_
#define GRASPING_MSGS__MSG__DETAIL__OBJECT_PROPERTY__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "grasping_msgs/msg/detail/object_property__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace grasping_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ObjectProperty & msg,
  std::ostream & out)
{
  out << "{";
  // member: name
  {
    out << "name: ";
    rosidl_generator_traits::value_to_yaml(msg.name, out);
    out << ", ";
  }

  // member: value
  {
    out << "value: ";
    rosidl_generator_traits::value_to_yaml(msg.value, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ObjectProperty & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "name: ";
    rosidl_generator_traits::value_to_yaml(msg.name, out);
    out << "\n";
  }

  // member: value
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "value: ";
    rosidl_generator_traits::value_to_yaml(msg.value, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ObjectProperty & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace grasping_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grasping_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grasping_msgs::msg::ObjectProperty & msg,
  std::ostream & out, size_t indentation = 0)
{
  grasping_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grasping_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const grasping_msgs::msg::ObjectProperty & msg)
{
  return grasping_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<grasping_msgs::msg::ObjectProperty>()
{
  return "grasping_msgs::msg::ObjectProperty";
}

template<>
inline const char * name<grasping_msgs::msg::ObjectProperty>()
{
  return "grasping_msgs/msg/ObjectProperty";
}

template<>
struct has_fixed_size<grasping_msgs::msg::ObjectProperty>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<grasping_msgs::msg::ObjectProperty>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<grasping_msgs::msg::ObjectProperty>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // GRASPING_MSGS__MSG__DETAIL__OBJECT_PROPERTY__TRAITS_HPP_
